/* Nokia 5110 LCD AVR Library example
 *
 * Copyright (C) 2015 Sergey Denisov.
 * Written by Sergey Denisov aka LittleBuster (DenisovS21@gmail.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public Licence
 * as published by the Free Software Foundation; either version 3
 * of the Licence, or (at your option) any later version.
 *
 * Original library written by SkewPL, http://skew.tk
 */

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "DHT11/DHT.h"
#include "nokia5110/nokia5110.h"
#include "main.h"

int main(void)
{
    nokia_lcd_init();
	start_turbine();
	init_gas();
	init_button();
	//init_timer1();
	int8_t temperature = 0;
	int8_t humidity = 0;
	int gas = 0;
	char gas_str[10] = {0}, humidity_str[10] = {0}, temperature_str[10] = {0};
	
	int count = 0, buttonCount = 0;
	while(1)
	{
		if(count%10 == 0){
			dht_gettemperaturehumidity(&temperature, &humidity);
			gas = readGas();
			itoa(gas, gas_str, 10);
			itoa(humidity, humidity_str, 10);
			itoa(temperature - 2, temperature_str, 10);
		}
			
		if(isButtonPressed()){
			buttonCount = 10;
		}

		if(buttonCount){
			buttonCount--;

			nokia_lcd_light_ON();
			if(temperature <= 18){
				strcpy(temperature_str,"Cold");
			}else if(temperature <= 25){
				strcpy(temperature_str,"Fine");
			}else{
				strcpy(temperature_str,"Hot");
			}

			if(humidity < 40){
				strcpy(humidity_str,"Low");
			}else if(humidity < 55){
				strcpy(humidity_str,"Fine");
			}else{
				strcpy(humidity_str,"High");
			}

			if(gas <= 30){
				strcpy(gas_str,"Pure");
			}else if(gas <= 50){
				strcpy(gas_str,"Clean");
			}else{
				strcpy(gas_str,"Impure");
			}
			print_sensors_values(gas_str, temperature_str, humidity_str, ModeAdvice);
		}else{
			print_sensors_values(gas_str, temperature_str, humidity_str, ModeValues);
			nokia_lcd_light_OFF();
		}
	_delay_ms(100);
	}
	
}
