#ifndef __MAIN_H__
#define __MAIN_H__
#define ModeValues 0
#define ModeAdvice 1 
#include <avr/pgmspace.h>
#include <stdint.h>

void nokia_lcd_light_toggle();
void nokia_lcd_light_ON();
void nokia_lcd_light_OFF();
void start_turbine();
void init_gas();
int readGas();
void init_button();
int isButtonPressed();
void print_sensors_values(char*, char*, char*, int);

void init_timer1();

void nokia_lcd_light_toggle(){
	DDRC |= (1<<PC7);
	if((PORTC & (1<<PC7)) == 0){
		//stins
		PORTC |= (1<<PC7);
	}else{
		//aprins
		PORTC &= ~(1<<PC7);
	}
}

void nokia_lcd_light_OFF(){
	DDRC |= (1<<PC7);
		//aprins
	PORTC &= ~(1<<PC7);
}

void nokia_lcd_light_ON(){
	DDRC |= (1<<PC7);
		//stins
	PORTC |= (1<<PC7);
}

void start_turbine(){
    //setez PC1 Output High
    DDRC |= (1<<PC1);
    PORTC &= ~(1<<PC1);
}


void init_gas(void)
{

	// Configure PORT A bit 0 to an input
	DDRA &= ~(1<<PA0);

	// Configure ADC to be left justified, use AVCC as reference, and select ADC0 as ADC input
	ADMUX = 0b01100000;

	// Enable the ADC and set the prescaler to max value (128)
	ADCSRA = 0b10000111;
}

int readGas(){
		// Start an ADC conversion by setting ADSC bit (bit 6)
		ADCSRA = ADCSRA | (1 << ADSC);
		
		// Wait until the ADSC bit has been cleared
		while(ADCSRA & (1 << ADSC));

		return ADCH;
}
void init_button(){
	DDRC &= ~(1<<PC0);
	PORTC |= (1<<PC0);
}


int isButtonPressed(){
	//PC0 intrare
	//Cu rezistenta de pull-up
	DDRC &= ~(1<<PC0);
	PORTC |= (1<<PC0);	

	if((PINC & (1<<PC0)) == 0){
		return 1;
	}
	return 0;
}

void init_timer1(){
	DDRD |= (1<<PD4);
	DDRD &= ~(1<<PD5);
	TCCR1A |= (1<<WGM10) | (1<<COM1B0) | (1<<COM1B1);
	TCCR1B |= (1<<WGM12) | (1<<CS10);
	OCR1B = 0XFF/8;
}

void print_sensors_values(char* gas, char* temperature, char* humidity, int mode){
	nokia_lcd_clear();
	nokia_lcd_set_cursor(0, 0);
	nokia_lcd_write_string("Tem: ", 2);
	
	if(mode == ModeValues){
		nokia_lcd_set_cursor(50, 0);
		nokia_lcd_write_string(temperature, 2);
		nokia_lcd_set_cursor(74, 0);
		nokia_lcd_write_string("*", 1);
	}else
	{
		nokia_lcd_set_cursor(45, 4);
		nokia_lcd_write_string(temperature, 1);
	}
	
	nokia_lcd_set_cursor(0, 17);
	nokia_lcd_write_string("Hum: ", 2);
	
	
	if(mode == ModeValues){
		humidity[2] = '%';
		humidity[3] = '\0';
		nokia_lcd_set_cursor(50, 17);
		nokia_lcd_write_string(humidity, 2);
	}else
	{
		nokia_lcd_set_cursor(45, 21);
		nokia_lcd_write_string(humidity, 1);
	}
	nokia_lcd_set_cursor(0, 34);
	nokia_lcd_write_string("Air: ", 2);
	
	
	if(mode == ModeValues){
		nokia_lcd_set_cursor(50, 34);
		nokia_lcd_write_string(gas, 2);
	}else
	{
		nokia_lcd_set_cursor(45, 38);
		nokia_lcd_write_string(gas, 1);
	}
	
	nokia_lcd_render();
}
#endif